sgu-205 Quantization Problem

题目大意:

给定一个n,然后一个数组S[n],然后给你一个m*s(m<=s)的矩阵A,然后要你求出一个数列k,满足∑i=1~n |  A[ k[i-1]  %m  ][ k[i] ]  -S[i] | 最小,输出最小值和其中一组解

解题思路:

显然这是一道明显的dp题,设f[i][j]表示对于k[i]取j的时候,最小值是多少,然后dp就行了

f[i][j]=MIN(f[i-1][g]+a[g%m][j])  (g=1~s  因为m<=s)

最后记录一个father输出就行了

AC代码:

#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cstring>
#include <iostream>
#include <algorithm>
#define MIN(a,b) ((a)>(b)?(b):(a))

using namespace std;
int t,n,m;
int s[1010]={0};
int a[150][150]={{0}};
int f[1010][150]={{0}};
int father[1010][150]={{0}};

void prt(int a,int b)
{
	if(a==0)
		return;
	prt(a-1,father[a][b]);
	cout<<b;
	if(a<t)
		cout<<' ';
	return;
}

int main()
{
	cin>>t;
	for(int i=1;i<=t;i++)
		scanf("%d",&s[i]);
	cin>>n>>m;
	for(int i=0;i<n;i++)
		for(int j=0;j<m;j++)
			scanf("%d",&a[i][j]);
	memset(f,0x3f3f3f3f,sizeof(f));
	f[0][0]=0;
	for(int i=1;i<=t;i++)
	{
		for(int j=0;j<m;j++)
		{
			for(int k=0;k<m;k++)
			{
				int tmp=f[i-1][k]+abs(a[k%n][j]-s[i]);
				if(tmp<f[i][j])
				{
					father[i][j]=k;
					f[i][j]=tmp;
				}
			}
		}
	}
	int ans=2e9,ansp=0;
	for(int i=0;i<m;i++)
		if(ans>f[t][i])
		{
			ans=f[t][i];
			ansp=i;
		}
	cout<<ans<<endl;
	prt(t,ansp);
	return 0;
}

∑ni=1|

i?1dm,Ki?Si

∑ni=1∑ni=1|AKi?1modm,Ki?Si|最小。

∑ni=1∑ni=1∑ni=1∑ni=1

时间: 2024-09-30 05:14:46

sgu-205 Quantization Problem的相关文章

SGU - 107 - 987654321 problem (简单数学!)

SGU - 107 987654321 problem Time Limit: 250MS   Memory Limit: 4096KB   64bit IO Format: %I64d & %I64u Submit Status Description For given number N you must output amount of N-digit numbers, such, that last digits of their square is equal to 987654321

acdream 1222 Quantization Problem [dp]

题目:acdream 1222 Quantization Problem 题意:给出一个序列 a ,然后给出一个 n * m 的矩阵,让你从这个矩阵中选出一个序列k,使得sum(abs(ki - ai))尽可能的小,首先第一个数只能在矩阵的第一行选第 x 个,然后以后每个在第 x%n 行选,依次选出最小即可.每个点可以选多次. 分析:这个题目难度在于题意,题意读懂了就简单了. 很明显的一个dp题目,我们定义状态:dp [i][j] :选第 i 个数 在第 j 列的最小和 则转移方程:dp [i]

ASC2 E Quantization Problem DP

题意:太难懂了,最开始给你一个数列 wi   ,还有一个转移矩阵 M[m][s], 你最开始只能从 M第一列选一个数 L1,如果选的第K个数,接下来只能从第 k&(m-1)取数, 问你|li-wi| 和的最小值及路径. 解题思路:DP加记录路径. 解题代码: 1 // File Name: e.cpp 2 // Author: darkdream 3 // Created Time: 2015年04月14日 星期二 20时35分51秒 4 5 #include<vector> 6 #i

暑假训练-个人赛第五场

    ID Origin Title   0 / 23 Problem A SGU 453 Meetings     Problem B SGU 454 Kakuro 10 / 58 Problem C SGU 455 Sequence analysis 14 / 52 Problem D SGU 456 Annuity Payment Scheme     Problem E SGU 457 Snow in Berland   0 / 1 Problem F SGU 458 The Mono

Google hosts持续更新地址

原文地址:http://blog.my-eclipse.cn/host-google.html 原更新地址:http://www.awolau.com/hosts/google-hosts.html 2015.6.26号使用: ---------------------------- 64.233.162.83    dl.google.com64.233.162.83    dl.l.google.com64.233.162.83    dl-ssl.google.com64.233.162.

Very simple problem - SGU 111(大数开方)

分析:使用的是构造新数字法进行不断构造,然后逼近每一位数字,然后使用c++徒手敲了240多行代码,竟然过了........................很有成就感. 代码如下: =============================================================================================================================== #include<stdio.h> #include<a

987654321 problem - SGU 107(找规律)

题目大意:求n位数的平方的后几位结果是987654321的个数是多少. 分析:刚看到这道题的时候怀疑过有没有这样的数,于是暴力跑了一下,发现还真有,9位的数有8个,如下: i=111111111, i*i=12345678987654321i=119357639, i*i=14246245987654321i=380642361, i*i=144888606987654321i=388888889, i*i=151234567987654321i=611111111, i*i=373456789

Codeforces Round#413 Problem A - C

[写在前面感(乱)叹(七)人(八)生(糟)的话] 本想借此机会一口气玩到蓝名,结果,A题写炸(少判了一种情况),C题写炸(辜负了我5分钟狂敲出来的线段树),结果又掉Rating...内心好绝望... Problem#A Carrot Cakes vjudge链接[here] (偷个懒,cf链接就不给了) 题目大意是说,烤面包,给出一段时间内可以考的面包数,建第二个炉子的时间,需要达到的面包数,问建炉子是否合理. 玄学 & 智商题,可能是因为我智商不够,所以在我决定休息的时候被hank掉了...

【SGU 390】Tickets (数位DP)

Tickets Description Conductor is quite a boring profession, as all you have to do is just to sell tickets to the passengers. So no wonder that once upon a time in a faraway galaxy one conductor decided to diversify this occupation. Now this conductor